unit Unit1;

{
 pendulum simulator
 slice time in microsecond  intervals and assume constant speed
 apply kinematic rule V := V+a*t
 a = g.sin(phi)

 v1.0  july 2022
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dav7RotationBtn, StdCtrls, Buttons, ExtCtrls, dav7components;

type
  TForm1 = class(TForm)
    PaintBox1: TPaintBox;
    gobtn: TSpeedButton;
    stopBtn: TSpeedButton;
    cyclelabel: TStaticText;
    Label1: TLabel;
    a10Btn: TDav7RotationBtn;
    a1Btn: TDav7RotationBtn;
    startlabel: TStaticText;
    Label2: TLabel;
    LmBtn: TDav7RotationBtn;
    LcmBtn: TDav7RotationBtn;
    linelabel: TStaticText;
    Label3: TLabel;
    acclabel: TStaticText;
    Label4: TLabel;
    msglabel: TStaticText;
    Label5: TLabel;
    timer: Tdav7Timer;
    proclabel: TStaticText;
    Label6: TLabel;
    Image1: TImage;
    Label7: TLabel;
    LmmBtn: TDav7RotationBtn;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure a10BtnChange(sender: TObject; position: Byte);
    procedure a1BtnChange(sender: TObject; position: Byte);
    procedure LmBtnChange(sender: TObject; position: Byte);
    procedure gobtnClick(Sender: TObject);
    procedure stopBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

const deg2rad : double = pi/180;
      rad2deg : double = 180/pi;
      pi2 : double = pi/2;


var bm : Tbitmap;
    Apos : double;     //angle in radians
    line : double;     //line length selection (m)
    ActiveLine : double; //actual line length in use
    Astart : word;     //start angle (degrees)
    stopFlag : boolean = true;

procedure paintbm;
const xtxt : array[0..18] of word = (25,32,48,70,100,142,188,237,289,345,
                                    400,450,500,546,585,616,640,654,660);
      ytxt : array[0..18] of word = (15,68,123,168,213,253,285,307,320,325,
                                    320,307,285,255,213,168,123,68,15);
var x1,y1,x2,y2 : word;
    a,rada,sina,cosa : single;
    i : shortInt;
begin
 with bm do with canvas do
  begin
   font.name := 'arial';
   font.height := 14;
   font.style := [];
   font.color := $000000;
   brush.color := $f0ffff;
   brush.Style := bsSolid;
   fillrect(rect(0,0,width,height));
   pen.Color := $000000;
   pen.Width := 1;
   brush.Style := bsClear;
   a := 0;
   rada := a*deg2rad;
   cosa := cos(rada);
   sina := sin(rada);
   x1 := round(350 - 300*cosa);
   y1 := round(20 + 300*sina);
   x2 := round(350 - 305*cosa);
   y2 := round(20 + 300*sina);
   moveto(x1,y1);
   lineto(x2,y2);
   moveto(x1,y1);
   for i := 0 to 35 do
    begin
     a := a + 5;
     rada := a*deg2rad;
     sina := sin(rada);
     cosa := cos(rada);
     x1 := round(350 - 300*cosa);
     y1 := round(20 + 300*sina);
     x2 := round(350 - 305*cosa);
     y2 := round(20 + 305*sina);
     lineto(x1,y1);
     lineto(x2,y2);
     moveto(x1,y1);
    end;
   for i := 0 to 18 do textout(xtxt[i],ytxt[i],inttostr(10*i-90));
   brush.Style := bsSolid;
   brush.color := $000000;
   pen.color := $000000;
   ellipse(345,15,355,25);
   pen.width := 2;
   moveto(350,20);
   cosa := cos(Apos);
   sina :=sin(Apos);
   x1 := round(350 + 298*sina);
   y1 := round(20 + 298*cosa);
   lineto(x1,y1);
   x1 := round(350 + 280*sina);
   y1 := round(20 + 280*cosa);
   ellipse(x1-12,y1-12,x1+12,y1+12);
  end;
end;

procedure bmrepaint;
begin
 paintbm;
 form1.paintbox1.canvas.draw(0,0,bm);
end;

procedure showlinetext;
const ff = '##0.###';
begin
 form1.linelabel.caption := formatfloat(ff,line);
end;

procedure showstartangle;
begin
 form1.startlabel.Caption := inttostr(Astart);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 bm := TBitmap.Create;
 with bm do
  begin
   width := paintbox1.Width;
   height := paintbox1.height;
   pixelformat := pf32bit;
  end;
 Apos := 0;//90 degrees
 A10Btn.position := 0;
 A1Btn.position := 0;
 startlabel.caption := inttostr(0);
 paintbm;
 LmBtn.position := 1;
 LcmBtn.position := 0;
 LmmBtn.position := 0;
 Line := 1;
 linelabel.Caption := inttostr(1);
 msglabel.caption := 'stopped';
 stopflag := true;
 A10Btn.ShowHint := true;
 LmBtn.ShowHint := true;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 bm.Free;
end;

procedure paintedges(ctrl : TControl;c1,c2 : dword; w : byte);
var i : byte;
    x1,y1,x2,y2 : word;
begin
 with form1 do
  begin
   x1 := ctrl.left - w;
   y1 := ctrl.top - w;
   x2 := ctrl.left + ctrl.width + w - 1;
   y2 := ctrl.top + ctrl.height + w - 1;
  end;
 with form1.Canvas do
  begin
   pen.Width :=1;
   for i := 0 to w-1 do
    begin
     pen.Color := c1;
     moveto(x2-i,y1+i);
     lineto(x1+i,y1+i);
     lineto(x1+i,y2-i);
     pen.Color := c2;
     lineto(x2-i,y2-i);
     lineto(x2-i,y1+i);
    end;
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
 paintedges(paintbox1,$000000,$808080,3);
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
 paintbox1.Canvas.Draw(0,0,bm);
end;

procedure EnableSelections(bv : boolean);
begin
 with form1 do
  begin
   A10Btn.enabled := bv;
   A1Btn.enabled := bv;
  end;
end;

function CalcMaxV : double;
//calculate maximum velocity
begin
 result := sqrt(2*9.8*activeline*(1 - cos(Apos)));
end;

procedure simulate;
var simsteps,wait : word;
    a,V,reportV,calcV,oldpos,dev,oldV,procTime : double;
    cycletime,reportcycletime : dword;
begin
 activeLine := line;
 cycletime := 0;
 reportcycletime := 0;
 V := 0;
 reportV := 0;
 Apos := Astart*deg2rad;  //pendumum  angle in radians
 calcV := calcMaxV;
 oldpos := 0;             //previous Apos
 oldV := 0;               //previous velocity
 wait := 100;             //delay to avoid too many updates of proc%
 repeat
  form1.timer.start;
  for simsteps := 1 to 10000 do    //10000 simulation steps of 1 microsec.
   begin
    inc(cycletime);
    Apos := Apos - (V/activeline)*1e-6;
    a := 9.8*sin(Apos);           //aceleration
    V := V + a*1e-6;              //new velocity
    if (oldpos >= 0) and (Apos < 0) then reportV := abs(V);
    oldPos := Apos;
    if (oldV < 0) and (V >= 0) then
     begin
      reportcycletime := cycletime;
      cycletime := 0;
      if line <> activeline then
       begin
        activeLine := line;
        calcV := calcMaxV;
       end;
     end;
    oldV := V;
   end;//for simsteps
//
  bmrepaint;
  if reportV > 0 then     //speed error report
   begin
    dev := 100*abs(reportV-calcV)/calcV;
    form1.acclabel.Caption := formatfloat('#0.0000000000',dev);
    reportV := 0;
   end;
  if reportcycletime > 0 then  //cycle time report
   begin
    form1.cyclelabel.Caption := formatfloat('#0.000###',reportcycletime*1e-6);
    reportcycletime := 0;
   end;
  dec(wait);
  if wait = 0 then        //proctime report only 1 in 100 steps
   begin
    form1.timer.stop;
    procTime := form1.timer.elapsedtime;
    form1.proclabel.caption := formatfloat('#0.0#',0.01*(proctime));
    wait := 100;
   end;
  application.ProcessMessages;
  repeat                 //delay to multiple of 10 milliseconds
   form1.timer.stop;
  until (form1.timer.Elapsedtime >= 10000) or stopflag; 
 until stopflag;
end;

procedure slowstop;
var deg : double;
begin
 deg := deg2rad;
 form1.msglabel.Caption := 'stopping...';
 repeat
  if Apos > 0 then Apos := Apos - deg
   else if Apos < 0 then Apos := Apos + deg;
  bmrepaint;
  form1.timer.start;
  repeat
   form1.timer.stop;
  until form1.timer.elapsedtime > 20000;
 until Abs(Apos) <= deg;
 Apos := 0;
 bmrepaint;
end;

procedure TForm1.a10BtnChange(sender: TObject; position: Byte);
begin
 Astart := A10Btn.position*10;
 A1Btn.position := 0;
 Apos := Astart*deg2rad;
 bmrepaint;
 showstartangle;
end;

procedure TForm1.a1BtnChange(sender: TObject; position: Byte);
begin
 Astart := A10Btn.position*10+A1Btn.position;
 if Astart > 90 then begin
                      A1Btn.position := 0;
                      Astart := 90;
                     end;
 Apos := Astart*deg2rad;
 bmrepaint;
 showstartangle;
end;

procedure TForm1.LmBtnChange(sender: TObject; position: Byte);
//common for all line length buttons
begin
 case TDav7RotationBtn(sender).tag of
  1 : if LmBtn.position > 0 then
       begin
        LcmBtn.position := 0;
        LmmBtn.position := 0;
       end;
  2 : if LcmBtn.position > 0 then LmmBtn.position := 0;
 end;//case
 line := LmBtn.position + LcmBtn.position*0.01 + lmmBtn.position*0.001;
 if line = 0 then begin
                   line := 0.5;
                   LcmBtn.position := 50;
                  end;
 showlinetext;
end;

procedure TForm1.gobtnClick(Sender: TObject);
begin
 if Astart = 0 then
  begin
   msglabel.caption := 'select start angle';
   exit;
  end;
 if line = 0 then
  begin
   msglabel.caption :='select line length';
   exit;
  end;
//
 enableSelections(false);
 msglabel.Caption := 'running';
 cyclelabel.Caption := '';
 acclabel.Caption := '';
 stopflag := false;
 simulate;
end;

procedure TForm1.stopBtnClick(Sender: TObject);
begin
 stopflag := true;
 slowstop;
 Astart := 0;
 A10Btn.position := 0;
 A1Btn.position := 0;
 showstartAngle;
 bmrepaint;
 msglabel.Caption := 'stopped';
 enableSelections(true);
 acclabel.Caption := '';
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 stopflag := true;
end;

end.
